

;===============================================================

.macro	play

wait    lda $d40b
        cmp #:1
        bne wait

	lda #:1
	sta $d01a

       	jsr player.sound

	lda #0
	sta $d01a
.endm

;===============================================================

	org $2000

	.proc main

	lda #0
	sta 559		; SCREEN OFF

	lda #$70
	ldx >msx
	ldy <msx
	jsr player.init

	ldx #0		;TMC
	txa
	jsr player.init

	lda #$10
	ldx #0
	jsr player.init

loop    lda 20
        cmp 20
        beq *-2

        jsr player.play		// pierwsze glowne wywolanie playera (1x na ramke)


	ift msx.fps = 2		// player wywolywany 2x na ramke

	play 48

	eli msx.fps = 3		// player wywolywany 3x na ramke

	play 20
	play 76

	eli msx.fps = 4		// player wywolywany 4x na ramke

	play 8
	play 48
	play 88

	eif

	lda $d20f
	and #12
	cmp #12
	bne return
	lda $d010
	beq return
	lda $d01f
	cmp #7
	bne return

        jmp loop

return	rts

        icl 'tmc_player.asm'
	icl 'tmc_relocator.mac'

;===============================================================

	.local msx
	tmc_relocator 'SN3.tmc' , msx
	.sav [6] ?length
	.endl

	.endp		;End of main

        run main
